# generated by datamodel-codegen:
#   filename:  materials_category/defects/zero_dimensional/point/base_configuration.json
#   version:   0.28.5

from __future__ import annotations

from enum import Enum
from typing import List, Optional

from pydantic import BaseModel, Field


class DefectType(Enum):
    vacancy = "vacancy"
    substitution = "substitution"
    interstitial = "interstitial"
    adatom = "adatom"


class BasePointDefectConfigurationSchema(BaseModel):
    defect_type: DefectType
    coordinate: List[float] = Field(..., max_length=3, min_length=3, title="coordinate 3d schema")
    chemical_element: Optional[str] = None
    """
    The chemical element for substitution or interstitial defects
    """
    use_cartesian_coordinates: Optional[bool] = False
    """
    Whether coordinates are in cartesian rather than fractional coordinates
    """
