# generated by datamodel-codegen:
#   filename:  properties_directory/non_scalar/total_energy_contributions.json
#   version:   0.28.5

from __future__ import annotations

from enum import Enum
from typing import Optional

from pydantic import BaseModel, Field


class Name(Enum):
    temperature_entropy = "temperature_entropy"


class ScalarSchema(BaseModel):
    name: Optional[Name] = None
    value: float


class Name98(Enum):
    harris_foulkes = "harris_foulkes"


class ScalarSchema9(BaseModel):
    name: Optional[Name98] = None
    value: float


class Name99(Enum):
    one_electron = "one_electron"


class ScalarSchema10(BaseModel):
    name: Optional[Name99] = None
    value: float


class Name100(Enum):
    hartree = "hartree"


class ScalarSchema11(BaseModel):
    name: Optional[Name100] = None
    value: float


class Name101(Enum):
    exchange = "exchange"


class ScalarSchema12(BaseModel):
    name: Optional[Name101] = None
    value: float


class Name102(Enum):
    exchange_correlation = "exchange_correlation"


class ScalarSchema13(BaseModel):
    name: Optional[Name102] = None
    value: float


class Name103(Enum):
    ewald = "ewald"


class ScalarSchema14(BaseModel):
    name: Optional[Name103] = None
    value: float


class Name104(Enum):
    alphaZ = "alphaZ"


class ScalarSchema15(BaseModel):
    name: Optional[Name104] = None
    value: float


class Name105(Enum):
    atomic_energy = "atomic_energy"


class ScalarSchema16(BaseModel):
    name: Optional[Name105] = None
    value: float


class Name106(Enum):
    eigenvalues = "eigenvalues"


class ScalarSchema17(BaseModel):
    name: Optional[Name106] = None
    value: float


class Name107(Enum):
    PAW_double_counting_correction_2 = "PAW_double-counting_correction_2"


class ScalarSchema18(BaseModel):
    name: Optional[Name107] = None
    value: float


class Name108(Enum):
    PAW_double_counting_correction_3 = "PAW_double-counting_correction_3"


class ScalarSchema19(BaseModel):
    name: Optional[Name108] = None
    value: float


class Name109(Enum):
    hartree_fock = "hartree_fock"


class ScalarSchema20(BaseModel):
    name: Optional[Name109] = None
    value: float


class Name110(Enum):
    total_energy_contributions = "total_energy_contributions"


class Units(Enum):
    kJ_mol = "kJ/mol"
    eV = "eV"
    J_mol = "J/mol"
    hartree = "hartree"
    cm_1 = "cm-1"
    Ry = "Ry"
    eV_atom = "eV/atom"


class TotalEnergyContributionsSchema(BaseModel):
    temperatureEntropy: Optional[ScalarSchema] = Field(None, title="scalar schema")
    """
    product of temperature and configurational entropy
    """
    harrisFoulkes: Optional[ScalarSchema9] = Field(None, title="scalar schema")
    """
    non self-consitent energy based on an input charge density
    """
    oneElectron: Optional[ScalarSchema10] = Field(None, title="scalar schema")
    """
    kinetic + pseudopotential energy
    """
    hartree: Optional[ScalarSchema11] = Field(None, title="scalar schema")
    """
    energy due to coulomb potential
    """
    exchange: Optional[ScalarSchema12] = Field(None, title="scalar schema")
    """
    exchange energy
    """
    exchangeCorrelation: Optional[ScalarSchema13] = Field(None, title="scalar schema")
    """
    exchange and correlation energy per particle
    """
    ewald: Optional[ScalarSchema14] = Field(None, title="scalar schema")
    """
    summation of interaction energies at long length scales due to coloumbic interactions
    """
    alphaZ: Optional[ScalarSchema15] = Field(None, title="scalar schema")
    """
    divergent electrostatic ion interaction in compensating electron gas
    """
    atomicEnergy: Optional[ScalarSchema16] = Field(None, title="scalar schema")
    """
    kinetic energy of wavefunctions in the atomic limit
    """
    eigenvalues: Optional[ScalarSchema17] = Field(None, title="scalar schema")
    """
    sum of one electron energies of kinetic, electrostatic, and exchange correlation
    """
    PAWDoubleCounting2: Optional[ScalarSchema18] = Field(None, title="scalar schema")
    """
    double counting correction 2
    """
    PAWDoubleCounting3: Optional[ScalarSchema19] = Field(None, title="scalar schema")
    """
    double counting correction 3
    """
    hartreeFock: Optional[ScalarSchema20] = Field(None, title="scalar schema")
    """
    hartree-fock contribution
    """
    name: Optional[Name110] = None
    units: Optional[Units] = None
